# ToDo List Assignment

In this project, we are going to create a ToDo List project. Just follow the steps:

1. Create a `ToDoItem.js` component. The component will be created under `components/ToDo` folder. ToDoItems will be mapped as `<li>` items.

    For Ex:

    ```html
    <ul className="todo-list">
        <!-- This are will map by developer: Start -->
        <li>
            <div className="item-id">1</div>
            <div className="item-text">Lorem Ipsum</div>
            <div className="item-date">124121515</div>
            <button className="btn-icon" onClick={deleteFunc}>X</button>
        </li>
        <!-- This are will map by developer: End -->
    <ul>
    ```

2. Load todo items with `Saga`. 

    - Define action type under `src/actions/actionTypes.js`
    - Define action under `src/actions/todo-actions.js`
    - Define reducer function under `src/reducer/todo-reducer.js`

    > Note: You must create 3 function for create load todo items.
    
    > Note 2: Don't forget to use `loading` information while fetching data.

    You will use this URL for fetching data from service.
    ```js
    // Load URL
    export const LOAD_TODOS_URL = "http://localhost:8080/todos";
    ```


3. Add Item to your ToDo List. Add items with Redux. 

    - Define action type under `src/actions/actionTypes.js`
    - Define action under `src/actions/todo-actions.js`
    - Define reducer function under `src/reducer/todo-reducer.js`

    ```javascript
    onAdd(item) {
		// Implement onAdd with redux
	}
    ```

    > **Important Note:** While creating onAdd function. You must add also **id** in `todo-reducer.js`. If you don't, you can't see the number of item in the left side.

4. Delete Item on ToDo List. Items will be deleted by Redux.

    - Define action type under `src/actions/actionTypes.js`
    - Define action under `src/actions/todo-actions.js`
    - Define reducer function under `src/reducer/todo-reducer.js`

    ```javascript
    onDelete(item) {
		// Implement onDelete with redux
	}
    ```

5. **Bonus:** Show item size under about screen. And the message should be like as below.

    ```html
    <h1>You have 5 todos in total</h1>;
    ```

    `Expected:` You must write with the ES6 templated string feature.