import React from 'react';
import { connect } from 'react-redux';
import { createSelector } from 'reselect';
import { loadTodos } from '../../actions/todo-actions';
import Heading from '../../components/Heading'
import ToDo from '../../components/ToDo'

export class Home extends React.Component {
	constructor(props) {
		super(props);
		this.onDelete = this.onDelete.bind(this);
		this.onAdd = this.onAdd.bind(this);
	}

	componentDidMount() {
		if (this.props.todos.todoList.length === 0) {
			// Dispatch the Load Todo Items function
		}
	}

	onDelete(index) {
		// Implement onDelete with redux
	}

	onAdd(item) {
		// Implement onAdd with redux
	}

	render() {
		return (
			<div className="home-container">
				<Heading title="ToDo List" />
				<ToDo data={this.props.todos.todoList} onAdd={this.onAdd} onDelete={this.onDelete} />
			</div>
		);
	}
}

const getTodoItems = createSelector(
	state => state.todoReducer,
	(todoReducer) => todoReducer.toJS()
)

const mapStateToProps = (state) => ({
	todos: getTodoItems(state)
})


const mapDispatchToProps = (dispatch) => {
	return {
		loadTodos: (todoList) => {
			dispatch(loadTodos(todoList))
		},
		// Write delete item function
		// Write add item function
	}
}

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(Home);