package com.todo.services;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.todo.model.Todo;

@RestController
@RequestMapping("/todos")
@CrossOrigin
public class StoreService {
	@Autowired
	TodoServiceStub service;


	@RequestMapping(method = RequestMethod.GET)
	public ResponseEntity<List<Todo>> getAll(HttpServletRequest request) {
		String code = request.getParameter("code");
		if (code != null) {
			return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(new ArrayList<Todo>());

		} else {
			return ResponseEntity.status(HttpStatus.OK).body(service.getTodos());
		}
	}

	@RequestMapping(value = "/{id}", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
	public Todo getById(@PathVariable("id") int id) {
		return service.get(id);
	}
	
	@RequestMapping(value = "/{id}", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.DELETE)
	public Todo removeById(@PathVariable("id") int id) {
		return service.remove(id);
	}
	
	@RequestMapping(value = "/{id}", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.PUT)
	public Todo update(@PathVariable("id") int id, @RequestBody Todo todo) {
		return service.update(id, todo);
	}
	
	@RequestMapping(produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
	public Todo create(@RequestBody Todo todo) {
		return service.save(todo);
	}

}
