package com.todo.services;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Component;

import com.todo.model.Todo;

@Component
public class TodoServiceStub {
	private List<Todo> todos = new ArrayList<Todo>();

	private TodoServiceStub() {
		super();
		init();
	}

	public Todo update(int id, Todo aTodo) {
		Todo old = get(id);
		todos.remove(old);
		aTodo.setId(id);
		todos.add(aTodo);
		return aTodo;
	}
	
	public Todo remove(int id) {
		Todo todo = get(id);
		todos.remove(todo);
		
		return todo;
	}
	
	public Todo save(Todo todo) {
		todo.setId((int)(Math.random()*100+10));
		todos.add(todo);		
		return todo;
	}

	public Todo get(int id) {
		Todo todo = null;
		for (Todo t : todos) {
			if (t.getId()==id)
				todo = t;
		}
		return todo;
	}

	private void init() {
		Todo t1 = new Todo(1, "Lorem ipsum dolor sit amet, eam justo petentium et, mel cu ubique dolorum oportere, his ei quando utamur. ");
		Todo t2 = new Todo(2, "Diam ridens copiosae eu sea. Eu vix harum nonumes incorrupte. ");
		Todo t3 = new Todo(3, "Pericula ocurreret eos ea, vidit verterem ne vel, ei commodo vidisse electram cum. ");
		Todo t4 = new Todo(4, "Ei stet exerci epicurei vim, aperiam explicari te vix, ad ludus oportere eam. Te eleifend delicata tincidunt his, sed error movet no. Ius ea oblique sensibus, ad dicam verterem usu.");
		Todo t5 = new Todo(5, "No qui modus molestie vivendum. Altera maiorum efficiendi ad per. ");

		
		todos.add(t1);
		todos.add(t2);
		todos.add(t3);
		todos.add(t4);
		todos.add(t5);

	}

	public List<Todo> getTodos() {
		return todos;
	}

}
